#include <SPI.h>
#include <TFT.h>

#define CS 10
#define DC 9
#define RESET 8
#define rightBtn 2
#define leftBtn 3
#define soundSen 5

TFT myScreen = TFT(CS, DC, RESET);

int rightB = 0;
int leftB = 0;
int soundVal = LOW;

int playerSize = 10;
int xPos = 80;
int yPos = myScreen.height() - 10;
int alienSize = 10;

int aiXPos = random(10, myScreen.width()- alienSize);
int aiYPos = random(10, myScreen.height()- alienSize - playerSize);

int xSpeed = 1;
int aiXSpeed = 1;


int xPrev = xPos;
int yPrev = yPos;

int aiXPrev = aiXPos;
int aiYPrev = aiYPos;

int bulletX = xPos;
int bulletY = yPos - 20;
int bulletSize = 4;
int bulletDir = 3;
int bulletPrevY = bulletY;
bool shot = false;

char printout[4];
int Score = 0;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  myScreen.begin();  
  pinMode(rightBtn, INPUT);
  pinMode(leftBtn, INPUT);
  pinMode(soundSen, INPUT);
  myScreen.background(0,0,0);
  NewTarget();
  myScreen.stroke(255,255,255);
  myScreen.text("Score:", 0,0);
}

void loop() {
  // put your main code here, to run repeatedly:

  rightB = digitalRead(rightBtn);
  leftB = digitalRead(leftBtn);
  soundVal = digitalRead(soundSen);
  
    
  if(rightB == HIGH)
  {
    xPos += xSpeed;
    //Serial.println(xPos);
  }
  
  if(leftB == HIGH)
  {
    xPos -= xSpeed;
  }

  if(leftB == HIGH && rightB == HIGH)
  {
    ResetGame();
  }

  if(soundVal == HIGH && shot == false)
  {
      myScreen.stroke(0,0,0);
      myScreen.fill(0,0,255);
      myScreen.rect(xPos,yPos,playerSize,playerSize);
      Shoot();
      shot = true;
      //Serial.println(shot);
      delay(100);
  }
  
  if(shot == true)
  {
    Serial.println(bulletX);
    bulletY -= bulletDir;

    if(bulletY != bulletPrevY)
    {
      myScreen.stroke(0,0,0);
      myScreen.fill(0,0,0);
      myScreen.circle(bulletX, bulletPrevY, bulletSize);
    }
    myScreen.stroke(0,0,0);
    myScreen.fill(0,255,0);
    myScreen.circle(bulletX, bulletY, bulletSize);

    bulletPrevY = bulletY;

    if(bulletY <= 10)
    {
      shot = false;
      myScreen.fill(0,0,0);
      myScreen.circle(bulletX, bulletPrevY, bulletSize);
    }
    
  }

  if(xPos != xPrev)
  {
    myScreen.stroke(0,0,0);
    myScreen.fill(0,0,0);
    myScreen.rect(xPrev,yPrev,playerSize,playerSize);
  }

  if(xPos >= (myScreen.width()-playerSize))
  {
    xPos = myScreen.width() -playerSize;
  }
  if(xPos <= 0)
  {
    xPos = 0;
  }
  
  myScreen.stroke(0,0,0);
  myScreen.fill(255,255,255);
  myScreen.rect(xPos,yPos,playerSize,playerSize);

  xPrev = xPos;

  //AI
  if(aiXPos != aiXPrev)
  {
    myScreen.stroke(0,0,0);
    myScreen.fill(0,0,0);
    myScreen.circle(aiXPrev,aiYPrev,alienSize);
  }

    if(aiYPos != aiYPrev)
  {
    myScreen.stroke(0,0,0);
    myScreen.fill(0,0,0);
    myScreen.circle(aiXPrev,aiYPrev,alienSize);
  }
  myScreen.stroke(0,0,0);
  myScreen.fill(255,0,0);
  myScreen.circle(aiXPos,aiYPos,alienSize);
  
  if(bulletY <= aiYPos && bulletX >= aiXPos-10 && bulletX <= aiXPos + alienSize)
  {
    Serial.println("shot");
    NewTarget();
    shot = false;
    Score += 1;
    myScreen.stroke(0,0,0);
    myScreen.text(printout,55,0);
    myScreen.fill(0,0,0);
    myScreen.circle(bulletX, bulletPrevY, bulletSize);
  }

  aiXPrev = aiXPos;
  aiYPrev = aiYPos;

  String scoreText = String(Score);
  scoreText.toCharArray(printout,4);
  myScreen.stroke(255,255,255);
  myScreen.text(printout,55,0);
  
  delay(30);
  }

  void NewTarget()
  { 
    aiXPos = random(10, myScreen.width()- alienSize);
    aiYPos = random(10, myScreen.height()- alienSize - playerSize);
    myScreen.fill(0,0,0);
    myScreen.circle(aiXPrev,aiYPrev,alienSize);
    myScreen.fill(255,0,0);
    myScreen.circle(aiXPos,aiYPos,alienSize);
    Serial.println(aiXPos);
    Serial.println(aiYPos);
    Serial.println(aiXPrev);
    Serial.println(aiYPrev);
  }

  void Shoot()
  {
    bulletX = xPos;
    bulletY = yPos - 20;
    myScreen.fill(0,255,0);
    myScreen.circle(bulletX, bulletY, bulletSize);
  }

  void ResetGame()
  {
    NewTarget();
    xPos = 80;
    yPos = myScreen.height() - 10;
    Score = 0;
  }

